<template>
  <b-container>
    <b-row>
      <b-col>
        <h3>{{ pageTitle }}</h3>
      </b-col>
    </b-row>
    <template v-if="tasks.length > 0">
      <b-row v-for="task in tasks" :key="task.uid" @click="selectTask(task)">
        <Task :task="task" />
      </b-row>
    </template>
    <template v-else>
      <div class="empty"><h5>{{ _('Нет подходящих заявок') }}</h5></div>
    </template>
  </b-container>
</template>

<script>
import Task from './Task'

import { CONFIG_SET_ACTIVE_LINK, PAGE_ACTIVE_TASK, PAGE_DONE_TASK,
  PAGE_SELF_TASK, TASKS_LOAD_ALL, TASKS_SELECT, PAGE_CURRENT_TASK } from '../data/actions-types'

export default {
  name: 'Tasks',
  components: {
    Task
  },
  mounted () {
    this.$store.dispatch(TASKS_LOAD_ALL)
  },
  computed: {
    pageTitle () {
      switch (this.$store.state.config.activeLink) {
        case PAGE_ACTIVE_TASK:
          return this._('Активные заявки')
        case PAGE_DONE_TASK:
          return this._('Завершенные заявки')
        case PAGE_SELF_TASK:
          return this._('Мои заявки')
        default:
          return this._('Все заявки')
      }
    },
    tasks () {
      switch (this.$store.state.config.activeLink) {
        case PAGE_ACTIVE_TASK:
          return this.$store.getters.activeTasks
        case PAGE_DONE_TASK:
          return this.$store.getters.doneTasks
        case PAGE_SELF_TASK:
          return this.$store.getters.selfTasks
        default:
          return this.$store.getters.allTasks
      }
    }
  },
  methods: {
    selectTask (task) {
      this.$store.dispatch(TASKS_SELECT, task)
      this.$store.dispatch(CONFIG_SET_ACTIVE_LINK, PAGE_CURRENT_TASK)
    }
  }
}
</script>

<style>
.empty {
  color: #ccc;
  padding: 24px;
  text-align: center;
  width: 100%;
}
</style>
